CREATE PROCEDURE [dbo].[KeihenReminderProcedure]
AS
BEGIN
	DECLARE @START_DATETIME DATETIME,
			@END_DATETIME DATETIME
	DECLARE @NOW_DATETIME DATETIME = GETDATE()
	DECLARE @PACK_MONTH VARCHAR(8) = ''
	DECLARE @TABLE TABLE (
		ROW_NO INT,
		PACK_MONTH VARCHAR(8),
		START_DATETIME DATETIME,
		END_DATETIME DATETIME
	)
	DECLARE @index INT = 1
	DECLARE @max INT = 0
	DECLARE @sendmailstatus VARCHAR(MAX) = ''

	INSERT INTO @TABLE
	SELECT 
		ROW_NUMBER() OVER(ORDER BY PACK_MONTH),
		PACK_MONTH,
		START,
		[END]
	FROM (
		SELECT 
			s.PACK_MONTH,
			MIN(s.FEEDBACK_REMINDER_START) START,
			MAX(s.FEEDBACK_REMINDER_END) [END]
		FROM TB_R_KEIHEN_SUMMARY s
		WHERE ISNULL(s.APPROVED_BY, '') <> ''
			  AND ISNULL(s.APPROVED_DT, '') <> ''
			  AND EXISTS(SELECT 'x' FROM TB_R_KEIHEN_FEEDBACK
						  WHERE	PACK_MONTH = s.PACK_MONTH
								AND SUPPLIER_CD = s.SUPPLIER_CD
								AND S_PLANT_CD = s.S_PLANT_CD
								AND ISNULL(FEEDBACK_BY, '') = ''
								AND ISNULL(FEEDBACK_DT, '') = '')
		GROUP BY PACK_MONTH
	) TBL1
	SELECT @max = ROW_NO FROM @TABLE

	WHILE(@index <= @max)
	BEGIN
		SELECT
			@PACK_MONTH = PACK_MONTH,
			@START_DATETIME = START_DATETIME,
			@END_DATETIME = END_DATETIME
		FROM @TABLE
		WHERE ROW_NO = @index

		IF(EXISTS(SELECT 'x' FROM TB_R_KEIHEN_FEEDBACK
				  WHERE PACK_MONTH = @PACK_MONTH
					    AND ISNULL(LOCK, '0') <> '1'))
		BEGIN
			IF(ISNULL(@START_DATETIME, '') <> '' 
			   AND ISNULL(@END_DATETIME, '') <> '')
			BEGIN
				IF(@NOW_DATETIME >= @START_DATETIME)
				BEGIN
					IF (@NOW_DATETIME <= @END_DATETIME)
					BEGIN
						EXEC KeihenMail 'REMINDER', @PACK_MONTH, 'Reminder', NULL, @END_DATETIME, @sendmailstatus OUTPUT
					END
					ELSE
					BEGIN
						UPDATE TB_R_KEIHEN_FEEDBACK
							SET LOCK = '1',
								FEEDBACK_BY = 'Reminder.Autolock',
								FEEDBACK_DT = GETDATE(),
								LOCK_BY = 'Reminder.Autolock',
								LOCK_DT = GETDATE(),
								CHANGED_BY = 'Reminder.Autolock',
								CHANGED_DT = GETDATE()
						WHERE PACK_MONTH = @PACK_MONTH
					END
				END
			END
		END

		SET @index = @index + 1
	END
END

